"use strict";
// Copyright (c) 2020 Shellyl_N and Authors
// license: ISC
// https://github.com/shellyln
Object.defineProperty(exports, "__esModule", { value: true });
// tslint:disable-next-line:function-constructor
const globalObj = Function('return this')();
const objConstructor = ({}).constructor; // NOTE: objConstructor            === Object
const funConstructor = Function; // NOTE: ({}).toString.constructor === Function
exports.SymbolPattern = /^[A-Za-z_$][A-Za-z0-9_$]*$/;
exports.NumberPattern = /^([\+\-]?\d*\.?\d+(?:[Ee][\+\-]?\d+)?)$/;
exports.DatePattern = /^(\d{4}-[01]\d-[0-3]\d)$/;
exports.DateTimePattern = /^((?:(?:\d{4}-[01]\d-[0-3]\dT[0-2]\d:[0-5]\d:[0-5]\d\.\d+)|(?:\d{4}-[01]\d-[0-3]\dT[0-2]\d:[0-5]\d:[0-5]\d)|(?:\d{4}-[01]\d-[0-3]\dT[0-2]\d:[0-5]\d))(?:[+-][0-2]\d:[0-5]\d|Z))$/;
exports.DateTimeNoTzPattern = /^((?:\d{4}-[01]\d-[0-3]\dT[0-2]\d:[0-5]\d:[0-5]\d\.\d+)|(?:\d{4}-[01]\d-[0-3]\dT[0-2]\d:[0-5]\d:[0-5]\d)|(?:\d{4}-[01]\d-[0-3]\dT[0-2]\d:[0-5]\d))$/;
exports.dummyTargetObject = {};
function isUnsafeVarNames(target, varName) {
    if (target === globalObj ||
        varName === '__proto__' ||
        varName === '__defineGetter__' || varName === '__defineSetter__' ||
        varName === '__lookupGetter__' || varName === '__lookupSetter__') {
        return true;
    }
    if (varName === 'prototype' || varName === 'constructor') {
        if (target === null || target === void 0 || typeof target === 'function') {
            return true;
        }
    }
    if (target === null || target === void 0 || target === objConstructor) {
        if (objConstructor.hasOwnProperty(varName)) {
            return true;
        }
    }
    if (target === null || target === void 0 || target === funConstructor) {
        // checking 'call', 'arguments', 'caller', ...
        let con = funConstructor;
        while (con) {
            if (con.hasOwnProperty(varName)) {
                return true;
            }
            con = con.__proto__;
        }
    }
    if (typeof target === 'function') {
        if (!target.hasOwnProperty(varName)) {
            // function's prototypes' members
            return true;
        }
    }
    return false;
}
exports.isUnsafeVarNames = isUnsafeVarNames;
function nvl(v, alt) {
    return (v !== null && v !== void 0 ? v : alt);
}
exports.nvl = nvl;
function nvl2(v, f, alt) {
    return (v !== null && v !== void 0 ? f(v) : alt);
}
exports.nvl2 = nvl2;
//# sourceMappingURL=util.js.map